Index: squid/doc/Programming-Guide/prog-guide.sgml
===================================================================
RCS file: /cvsroot/squid-sf//squid/doc/Programming-Guide/prog-guide.sgml,v
retrieving revision 1.1.1.2.6.1
retrieving revision 1.1.1.2.6.1.2.1
diff -u -r1.1.1.2.6.1 -r1.1.1.2.6.1.2.1
--- squid/doc/Programming-Guide/prog-guide.sgml	20 Apr 2000 18:14:20 -0000	1.1.1.2.6.1
+++ squid/doc/Programming-Guide/prog-guide.sgml	2 May 2000 22:50:28 -0000	1.1.1.2.6.1.2.1
@@ -1130,9 +1533,301 @@
 	to become the official state-holding log.
 
 
+<sect1>Replacement policy implementation
+
+<P>
+The replacement policy can be updated during STOBJREAD/STOBJWRITE/STOBJOPEN/
+STOBJCLOSE as well as STREFOBJ and STUNREFOBJ. Care should be taken to
+only modify the relevant replacement policy entries in the StoreEntry.
+The responsibility of replacement policy maintainence has been moved into
+each SwapDir so that the storage code can have tight control of the
+replacement policy. Cyclic filesystems such as COSS require this tight
+coupling between the storage layer and the replacement policy.
+
+
+<sect1>Future removal policy
+
+	<P>
+	(replaces the above Replace policy)
+
+	<P>
+	The removal policy is responsible for determining in which order
+	objects are deleted when Squid needs to reclaim space for new objects.
+	Such a policy is used by a object storage for maintaining the stored
+	objects and determining what to remove to reclaim space for new objects.
+	(together they implements a replacement policy)
+	
+<sect2>API
+	<P>
+	It is implemented as a modular API where a storage directory or
+	memory creates a policy of choice for maintaining it's objects,
+	and modules registerering to be used by this API.
+
+<sect3>createRemovalPolicy()
+
+<P>
+<verb>
+	RemovalPolicy policy = createRemovalPolicy(cons char *type, cons char *args)
+</verb>
+
+	<P>
+	Creates a removal policy instance where object priority can be
+	maintained
+
+	<P>
+	The returned RemovalPolicy instance is cbdata registered
+
+<sect3>policy.Free()
+	
+	<P>
+<verb>
+	policy-&gt;Free(RemovalPolicy *policy)
+</verb>
+
+<P>
+	Destroys the policy instance and frees all related memory.
+
+<sect3>policy.Add()
+
+<P>
+<verb>
+	policy-&gt;Add(RemovalPolicy *policy, StoreEntry *, RemovalPolicyNode *node)
+</verb>
+
+	<P>
+	Adds a StoreEntry to the policy instance.
+	
+	<P>
+	datap is a pointer to where policy specific data can be stored
+	for the store entry, currently the size of one (void *) pointer.
+
+<sect3>policy.Remove()
+
+<P>
+<verb>
+	policy-&gt;Remove(RemovalPolicy *policy, StoreEntry *, RemovalPolicyNode *node)
+</verb>
+
+	<P>
+	Removes a StoreEntry from the policy instance out of
+	policy order. For example when an object is replaced
+	by a newer one or is manually purged from the store.
+
+	<P>
+	datap is a pointer to where policy specific data is stored
+	for the store entry, currently the size of one (void *) pointer.
+
+<sect3>policy.Referenced()
+
+<P>
+<verb>
+	policy-&gt;Referenced(RemovalPolicy *policy, const StoreEntry *, RemovalPolicyNode *node)
+</verb>
+
+	<P>
+	Tells the policy that a StoreEntry has been referenced.
+
+	<P>
+	datap is a pointer to where policy specific data is stored
+	for the store entry, currently the size of one (void *) pointer.
+
+<sect3>policy.WalkInit()
+
+<P>
+<verb>
+	RemovalPolicyWalker walker = policy-&gt;WalkInit(RemovalPolicy *policy)
+</verb>
+
+	<P>
+	Initiates a walk of all objects in the policy instance.
+	The objects is returned in an order suitable for using
+	as reinsertion order when rebuilding the policy.
+
+	<P>
+	The returned RemovalPolicyWalker instance is cbdata registered
+
+	<P>
+	Note: The walk must be performed as an atomic operation
+	with no other policy actions interveaning, or the outcome
+	will be undefined.
+
+<sect3>walker.Next()
+
+	<P>
+<verb>
+	const StoreEntry *entry = walker-&gt;Next(RemovalPolicyWalker *walker)
+</verb>
+
+<P>
+	Gets the next object in the walk chain
+
+	<P>
+	Return NULL when there is no further objects
+
+<sect3>walker.Done()
+
+<P>
+<verb>
+	walker-&gt;Done(RemovalPolicyWalker *walker)
+</verb>
+
+	<P>
+	Finishes a walk of the maintaned objects, destroys
+	walker.
+
+<sect3>policy.PurgeInit()
+
+<P>
+<verb>
+	RemovalPurgeWalker purgewalker = policy-&gt;PurgeInit(RemovalPolicy *policy, int max_scan)
+</verb>
+
+	<P>
+	Initiates a search for removal candidates. Seach depth is indicated
+	by max_scan.
+
+	<P>
+	The returned RemovalPurgeWalker instance is cbdata registered
+
+	<P>
+	Note: The walk must be performed as an atomic operation
+	with no other policy actions interveaning, or the outcome
+	will be undefined.
+
+<sect3>purgewalker.Next()
+
+<P>
+<verb>
+	StoreEntry *entry = purgewalker-&gt;Next(RemovalPurgeWalker *purgewalker)
+</verb>
+
+	<P>
+	Gets the next object to purge. The purgewalker will remove each
+	returned object from the policy.
+	
+	<P>It is the policys responsibility to verify that the object
+	isn't locked or otherwise prevented from being removed. What this
+	means is that the policy must not return objects where
+	storeEntryLocked() is true.
+
+	<P>
+	Return NULL when there is no further purgeable objects in the policy.
+
+<sect3>purgewalker.Done()
+
+<P>
+<verb>
+	purgewalker-&gt;Done(RemovalPurgeWalker *purgewalker)
+</verb>
+
+	<P>
+	Finishes a walk of the maintaned objects, destroys
+	walker and restores the policy to it's normal state.
+
+<sect2>Future removal policy implementation
+
+<sect3>Source layout
+
+<P>
+	Policy implementations resides in src/repl/&lt;name&gt;/, and a make in
+	such a directory must result in a object archive src/repl/&lt;name&gt;.a
+	containing all the objects implementing the policy.
+
+<sect3>Internal structures
+
+<sect4>RemovalPolicy
+
+<P>
+<verb>
+	typedef struct _RemovalPolicy RemovalPolicy;
+	struct _RemovalPolicy {
+	    char *_type;
+	    void *_data;
+	    void (*add)(RemovalPolicy *policy, StoreEntry *);
+	    ... /* see the API definition above */
+	};
+</verb>
+
+<P>
+	The _type member is mainly for debugging and diagnostics purposes, and
+	should be a pointer to the name of the policy (same name as used for
+	creation)
+
+<P>
+	The _data member is for storing policy specific information.
+
+<sect4>RemovalPolicyWalker
+
+<P>
+<verb>
+	typedef struct _RemovalPolicyWalker RemovalPolicyWalker;
+	struct _RemovalPolicyWalker {
+	    RemovalPolicy *_policy;
+	    void *_data;
+	    StoreEntry *(*next)(RemovalPolicyWalker *);
+	    ... /* see the API definition above */
+	};
+</verb>
+
+<sect4>RemovalPolicyNode
+
+<P>
+<verb>
+	typedef struct _RemovalPolicyNode RemovalPolicyNode;
+	struct _RemovalPolicyNode {
+	    void *data;
+	};
+</verb>
+
+	Stores policy specific information about a entry. Currently
+	there is only space for a single pointer, but plans are to
+	maybe later provide more space here to allow simple policies
+	to store all their data "inline" to preserve some memory.
+
+<sect3>Policy registration
+
+<P>
+	Policies are automatically registered in the Squid binary from the
+	policy selection made by the user building Squid. In the future this
+	might get extended to support loadable modules. All registered
+	policies are available to object stores which wishes to use them.
+
+<sect3>Policy instance creation
+
+<P>
+	Each policy must implement a "create/new" function "<tt/RemovalPolicy *
+	createRemovalPolicy_&lt;name&gt;(char *arguments)/". This function
+	creates the policy instance and populates it with at least the API
+	methods supported. Currently all API calls are mandatory, but the
+	policy implementation must make sure to NULL fill the structure prior
+	to populating it in order to assure future API compability.
+
+<P>
+	It should also populate the _data member with a pointer to policy
+	specific data.
+
+<P>
+	Prior to returning the created instance must be registered as
+	callback-data by calling cbdataAdd().
+
+<sect3>Walker
+
+<P>
+	When a walker is created the policy populates it with at least the API
+	methods supported. Currently all API calls are mandatory, but the
+	policy implementation must make sure to NULL fill the structure prior
+	to populating it in order to assure future API compability.
+
+<P>
+	Prior to returning the created instance must be registered as
+	callback-data by calling cbdataAdd().
+
 <!-- %%%% Chapter : FORWARDING SELECTION %%%% -->
 <sect>Forwarding Selection
 
+	<P>
+	To be written...
+
 <!-- %%%% Chapter : IP/FQDN CACHE %%%% -->
 <sect>IP Cache and FQDN Cache
 
@@ -1217,30 +1912,72 @@
 <!-- %%%% Chapter : SERVER PROTOCOLS %%%% -->
 <sect>Server Protocols
 <sect1>HTTP
+
+	<P>
+	To be written...
+
 <sect1>FTP
+
+	<P>
+	To be written...
+
 <sect1>Gopher
+
+	<P>
+	To be written...
+
 <sect1>Wais
+
+	<P>
+	To be written...
+
 <sect1>SSL
+
+	<P>
+	To be written...
+
 <sect1>Passthrough
 
+	<P>
+	To be written...
+
 <!-- %%%% Chapter : TIMEOUTS %%%% -->
 <sect>Timeouts
 
+	<P>
+	To be written...
+
 <!-- %%%% Chapter : EVENTS %%%% -->
 <sect>Events
 
+	<P>
+	To be written...
+
 <!-- %%%% Chapter : ACCESS CONTROLS %%%% -->
 <sect>Access Controls
 
+	<P>
+	To be written...
+
 <!-- %%%% Chapter : ICP %%%% -->
 <sect>ICP
 
+	<P>
+	To be written...
+
 <!-- %%%% Chapter : NETDB %%%% -->
 <sect>Network Measurement Database
 
+	<P>
+	To be written...
+
 <!-- %%%% Chapter : Error Pages %%%% -->
 <sect>Error Pages
 
+	<P>
+	To be written...
+
+<!-- %%%% Chapter : Callback Data Base %%%% -->
 <sect>Callback Data Database
 
 	<P>
@@ -1309,6 +2046,9 @@
 <!-- %%%% Chapter : CACHE MANAGER %%%% -->
 <sect>Cache Manager
 
+	<P>
+	To be written...
+
 <!-- %%%% Chapter : HTTP Headers %%%% -->
 <sect>HTTP Headers
 
Index: squid/src/access_log.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/access_log.c,v
retrieving revision 1.1.1.3.10.2
retrieving revision 1.1.1.3.10.2.2.1
diff -u -r1.1.1.3.10.2 -r1.1.1.3.10.2.2.1
--- squid/src/access_log.c	20 Apr 2000 18:14:21 -0000	1.1.1.3.10.2
+++ squid/src/access_log.c	2 May 2000 22:50:28 -0000	1.1.1.3.10.2.2.1
@@ -1,7 +1,6 @@
 
-
 /*
- * $Id: access_log.c,v 1.1.1.3.10.2 2000/04/20 18:14:21 hno Exp $
+ * $Id: access_log.c,v 1.1.1.3.10.2.2.1 2000/05/02 22:50:28 hno Exp $
  *
  * DEBUG: section 46    Access Log
  * AUTHOR: Duane Wessels
@@ -37,7 +36,6 @@
 
 #include "squid.h"
 
-char *log_quote(const char *header);
 static void accessLogSquid(AccessLogEntry * al);
 static void accessLogCommon(AccessLogEntry * al);
 static Logfile *logfile = NULL;
Index: squid/src/acl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/acl.c,v
retrieving revision 1.1.1.3.10.5
retrieving revision 1.1.1.3.10.5.2.1
diff -u -r1.1.1.3.10.5 -r1.1.1.3.10.5.2.1
--- squid/src/acl.c	22 Apr 2000 09:18:51 -0000	1.1.1.3.10.5
+++ squid/src/acl.c	2 May 2000 22:50:28 -0000	1.1.1.3.10.5.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: acl.c,v 1.1.1.3.10.5 2000/04/22 09:18:51 hno Exp $
+ * $Id: acl.c,v 1.1.1.3.10.5.2.1 2000/05/02 22:50:28 hno Exp $
  *
  * DEBUG: section 28    Access Control
  * AUTHOR: Duane Wessels
@@ -1152,17 +1152,20 @@
 		return 0; /* NOTREACHED */
 	    }
 	} else {
-	    /* user has switched to another IP addr */
-	    debug(28, 1) ("aclMatchProxyAuth: user '%s' has changed IP address\n", user);
-	    if (!Config.authenticateIpTTL > 0) {
+	    if (Config.onoff.authenticateIpTTLStrict) {
+		/* Access from some other IP address than the one owning
+		 * this user ID. Deny access
+		 */
+		debug(28, 1) ("aclMatchProxyAuth: user '%s' tries to use multple IP addresses!\n", user);
+		return 0;
+	    } else {
+		/* user has switched to another IP addr */
+		debug(28, 1) ("aclMatchProxyAuth: user '%s' has changed IP address\n", user);
 		/* remove this user from the hash, making him unknown */
 		hash_remove_link(proxy_auth_cache, (hash_link *) auth_user);
 		aclFreeProxyAuthUser(auth_user);
 		/* require the user to reauthenticate */
 		return -2;
-	    } else {
-		/* Strict TTL is set. Deny the "other" user access */
-		return 0;
 	    }
 	}
     } else {
@@ -2305,9 +2308,14 @@
  *
  * NOTE: Linux code by David Luyer <luyer@ucs.uwa.edu.au>.
  *       Original (BSD-specific) code no longer works.
+ *       Solaris code by R. Gancarz <radekg@solaris.elektrownia-lagisza.com.pl>
  */
 
+#ifdef _SQUID_SOLARIS_
+#include <sys/sockio.h>
+#else
 #include <sys/sysctl.h>
+#endif
 #ifdef _SQUID_LINUX_
 #include <net/if_arp.h>
 #include <sys/ioctl.h>
@@ -2382,10 +2390,10 @@
 /***************/
 /* aclMatchArp */
 /***************/
-#ifdef _SQUID_LINUX_
 static int
 aclMatchArp(void *dataptr, struct in_addr c)
 {
+#if defined(_SQUID_LINUX_)
     struct arpreq arpReq;
     struct sockaddr_in ipAddr;
     unsigned char ifbuffer[sizeof(struct ifreq) * 64];
@@ -2499,6 +2507,48 @@
 	 * exist on multiple interfaces?
 	 */
     }
+#elif defined(_SQUID_SOLARIS_)
+    struct arpreq arpReq;
+    struct sockaddr_in ipAddr;
+    unsigned char ifbuffer[sizeof(struct ifreq) * 64];
+    struct ifconf ifc;
+    struct ifreq *ifr;
+    int offset;
+    splayNode **Top = dataptr;
+    /*
+     * Set up structures for ARP lookup with blank interface name
+     */
+    ipAddr.sin_family = AF_INET;
+    ipAddr.sin_port = 0;
+    ipAddr.sin_addr = c;
+    memset(&arpReq, '\0', sizeof(arpReq));
+    memcpy(&arpReq.arp_pa, &ipAddr, sizeof(struct sockaddr_in));
+    /* Query ARP table */
+    if (ioctl(HttpSockets[0], SIOCGARP, &arpReq) != -1) {
+	/*
+	 *  Solaris (at least 2.6/x86) does not use arp_ha.sa_family -
+	 * it returns 00:00:00:00:00:00 for non-ethernet media 
+	 */
+	if (arpReq.arp_ha.sa_data[0] == 0 &&
+	    arpReq.arp_ha.sa_data[1] == 0 &&
+	    arpReq.arp_ha.sa_data[2] == 0 &&
+	    arpReq.arp_ha.sa_data[3] == 0 &&
+	    arpReq.arp_ha.sa_data[4] == 0 &&
+	    arpReq.arp_ha.sa_data[5] == 0)
+	    return 0;
+	debug(28, 4) ("Got address %02x:%02x:%02x:%02x:%02x:%02x\n",
+	    arpReq.arp_ha.sa_data[0] & 0xff, arpReq.arp_ha.sa_data[1] & 0xff,
+	    arpReq.arp_ha.sa_data[2] & 0xff, arpReq.arp_ha.sa_data[3] & 0xff,
+	    arpReq.arp_ha.sa_data[4] & 0xff, arpReq.arp_ha.sa_data[5] & 0xff);
+	/* Do lookup */
+	*Top = splay_splay(&arpReq.arp_ha.sa_data, *Top, aclArpCompare);
+	debug(28, 3) ("aclMatchArp: '%s' %s\n",
+	    inet_ntoa(c), splayLastResult ? "NOT found" : "found");
+	return (0 == splayLastResult);
+    }
+#else
+    WRITE ME;
+#endif
     /*
      * Address was not found on any interface
      */
@@ -2509,6 +2559,7 @@
 static int
 aclArpCompare(const void *a, const void *b)
 {
+#if defined(_SQUID_LINUX_)
     const unsigned short *d1 = a;
     const unsigned short *d2 = b;
     if (d1[0] != d2[0])
@@ -2517,22 +2568,28 @@
 	return (d1[1] > d2[1]) ? 1 : -1;
     if (d1[2] != d2[2])
 	return (d1[2] > d2[2]) ? 1 : -1;
-    return 0;
-}
+#elif defined(_SQUID_SOLARIS_)
+    const unsigned char *d1 = a;
+    const unsigned char *d2 = b;
+    if (d1[0] != d2[0])
+	return (d1[0] > d2[0]) ? 1 : -1;
+    if (d1[1] != d2[1])
+	return (d1[1] > d2[1]) ? 1 : -1;
+    if (d1[2] != d2[2])
+	return (d1[2] > d2[2]) ? 1 : -1;
+    if (d1[3] != d2[3])
+	return (d1[3] > d2[3]) ? 1 : -1;
+    if (d1[4] != d2[4])
+	return (d1[4] > d2[4]) ? 1 : -1;
+    if (d1[5] != d2[5])
+	return (d1[5] > d2[5]) ? 1 : -1;
 #else
-
-static int
-aclMatchArp(void *dataptr, struct in_addr c)
-{
-    WRITE ME;
-}
-
-static int
-aclArpCompare(const void *data, splayNode * n)
-{
     WRITE ME;
+#endif
+    return 0;
 }
 
+#if UNUSED_CODE
 /**********************************************************************
 * This is from the pre-splay-tree code for BSD
 * I suspect the Linux approach will work on most O/S and be much
Index: squid/src/cf.data.pre
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.pre,v
retrieving revision 1.1.1.3.10.6.2.1
retrieving revision 1.1.1.3.10.6.2.2
diff -u -r1.1.1.3.10.6.2.1 -r1.1.1.3.10.6.2.2
--- squid/src/cf.data.pre	23 Apr 2000 09:55:37 -0000	1.1.1.3.10.6.2.1
+++ squid/src/cf.data.pre	2 May 2000 22:50:28 -0000	1.1.1.3.10.6.2.2
@@ -1,6 +1,6 @@
 
 #
-# $Id: cf.data.pre,v 1.1.1.3.10.6.2.1 2000/04/23 09:55:37 hno Exp $
+# $Id: cf.data.pre,v 1.1.1.3.10.6.2.2 2000/05/02 22:50:28 hno Exp $
 #
 #
 # SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -712,6 +712,16 @@
 	information that Squid-specific log analyzers use.
 DOC_END
 
+NAME: log_ip_on_direct
+COMMENT: on|off
+TYPE: onoff
+DEFAULT: on
+LOC: Config.onoff.log_ip_on_direct
+DOC_START
+	Log the destination IP address in the hierarchy log tag when going
+	direct. Earlier Squid versions logged the hostname here. If you
+	prefer the old way set this to off.
+DOC_END
 
 NAME: mime_table
 TYPE: string
@@ -880,6 +890,7 @@
 TYPE: onoff
 DEFAULT: off
 LOC: Config.onoff.res_defnames
+IFDEF: USE_DNSSERVERS
 DOC_START
 	Normally the 'dnsserver' disables the RES_DEFNAMES resolver
 	option (see res_init(3)).  This prevents caches in a hierarchy
@@ -1027,9 +1038,22 @@
 	until the TTL has expired.
 
 	The default is 0 to disable the check. Recommended value
-	if you have dialup users are no more than 60 seconds. If
-	all your users are stationary then higher values may be
-	used, or even strict checking.
+	if you have dialup users are no more than 60 seconds to allow
+	the user to redial without hassle. If all your users are
+	stationary then higher values may be used.
+
+	See also authenticate_ip_ttl_is_strict
+DOC_END
+
+NAME: authenticate_ip_ttl_is_strict
+TYPE: onoff
+LOC: Config.onoff.authenticateIpTTLStrict
+DEFAULT: on
+DOC_START
+	This option makes authenticate_ip_ttl a bit stricted. With this
+	enabled authenticate_ip_ttl will deny all access from other IP
+	addresses until the TTL has expired, and the IP address "owning"
+	the userid will not be forced to reauthenticate.
 DOC_END
 
 COMMENT_START
@@ -1453,9 +1477,6 @@
 DOC_START
 	Timeout for idle persistent connections to clients, servers
 	and other proxies.
-	
-	Persistent connections will be disabled if this is less than 10
-	seconds.
 DOC_END
 
 NAME: ident_timeout
@@ -3125,7 +3146,9 @@
 TYPE: int
 LOC: Config.diskd.magic2
 DEFAULT: 72
-DOC_NONE
+DOC_START
+	Macic constants for the diskd daemon..
+DOC_END
 
 EOF
 
Index: squid/src/cf_gen.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf_gen.c,v
retrieving revision 1.1.1.3.10.2
retrieving revision 1.1.1.3.10.2.2.1
diff -u -r1.1.1.3.10.2 -r1.1.1.3.10.2.2.1
--- squid/src/cf_gen.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.10.2
+++ squid/src/cf_gen.c	2 May 2000 22:50:28 -0000	1.1.1.3.10.2.2.1
@@ -1,5 +1,6 @@
+
 /*
- * $Id: cf_gen.c,v 1.1.1.3.10.2 2000/04/20 18:14:22 hno Exp $
+ * $Id: cf_gen.c,v 1.1.1.3.10.2.2.1 2000/05/02 22:50:28 hno Exp $
  *
  * DEBUG: none
  * AUTHOR: Max Okumoto
Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.1.1.3.10.7
retrieving revision 1.1.1.3.10.7.2.1
diff -u -r1.1.1.3.10.7 -r1.1.1.3.10.7.2.1
--- squid/src/client_side.c	21 Apr 2000 22:17:08 -0000	1.1.1.3.10.7
+++ squid/src/client_side.c	2 May 2000 22:50:28 -0000	1.1.1.3.10.7.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: client_side.c,v 1.1.1.3.10.7 2000/04/21 22:17:08 hno Exp $
+ * $Id: client_side.c,v 1.1.1.3.10.7.2.1 2000/05/02 22:50:28 hno Exp $
  *
  * DEBUG: section 33    Client-side Routines
  * AUTHOR: Duane Wessels
@@ -200,7 +200,8 @@
 #if DELAY_POOLS
     delaySetStoreClient(e, h, delayClient(h->request));
 #endif
-    storeClientCopy(e, 0, 0, 0, NULL, clientSendMoreData, h);
+    storeClientCopy(e, 0, 0, CLIENT_SOCK_SZ,
+	memAllocate(MEM_CLIENT_SOCK_BUF), clientSendMoreData, h);
     return e;
 }
 
@@ -374,8 +375,8 @@
     storeClientCopy(entry,
 	http->out.offset,
 	http->out.offset,
-	0,
-	NULL,
+	CLIENT_SOCK_SZ,
+	memAllocate(MEM_CLIENT_SOCK_BUF),
 	clientHandleIMSReply,
 	http);
 }
@@ -431,9 +432,11 @@
     http_status status;
     debug(33, 3) ("clientHandleIMSReply: %s, %d bytes\n", url, (int) size);
     if (entry == NULL) {
+	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	return;
     }
     if (size < 0 && !EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	return;
     }
     mem = entry->mem_obj;
@@ -448,7 +451,7 @@
 	entry = http->entry = http->old_entry;
     } else if (STORE_PENDING == entry->store_status && 0 == status) {
 	debug(33, 3) ("clientHandleIMSReply: Incomplete headers for '%s'\n", url);
-	if (size >= SM_PAGE_SIZE) {
+	if (size >= CLIENT_SOCK_SZ) {
 	    /* will not get any bigger than that */
 	    debug(33, 3) ("clientHandleIMSReply: Reply is too large '%s', using old entry\n", url);
 	    /* use old entry, this repeats the code abovez */
@@ -461,8 +464,8 @@
 	    storeClientCopy(entry,
 		http->out.offset + size,
 		http->out.offset,
-		0,
-		NULL,
+		CLIENT_SOCK_SZ,
+		buf,
 		clientHandleIMSReply,
 		http);
 	    return;
@@ -510,8 +513,8 @@
 	storeClientCopy(entry,
 	    http->out.offset,
 	    http->out.offset,
-	    0,
-	    NULL,
+	    CLIENT_SOCK_SZ,
+	    buf,
 	    clientSendMoreData,
 	    http);
     } else {
@@ -2013,10 +2016,12 @@
     request_t *r = http->request;
     debug(33, 3) ("clientCacheHit: %s, %d bytes\n", http->uri, (int) size);
     if (http->entry == NULL) {
+	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	debug(33, 3) ("clientCacheHit: request aborted\n");
 	return;
     } else if (size < 0) {
 	/* swap in failure */
+	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	debug(33, 3) ("clientCacheHit: swapin failure for %s\n", http->uri);
 	http->log_type = LOG_TCP_SWAPFAIL_MISS;
 	if ((e = http->entry)) {
@@ -2036,16 +2041,18 @@
 	 * punt to clientProcessMiss.
 	 */
 	if (e->mem_status == IN_MEMORY || e->store_status == STORE_OK) {
+	    memFree(buf, MEM_CLIENT_SOCK_BUF);
 	    clientProcessMiss(http);
-	} else if (size == SM_PAGE_SIZE && http->out.offset == 0) {
+	} else if (size == CLIENT_SOCK_SZ && http->out.offset == 0) {
+	    memFree(buf, MEM_CLIENT_SOCK_BUF);
 	    clientProcessMiss(http);
 	} else {
 	    debug(33, 3) ("clientCacheHit: waiting for HTTP reply headers\n");
 	    storeClientCopy(e,
 		http->out.offset + size,
 		http->out.offset,
-		0,
-		NULL,
+		CLIENT_SOCK_SZ,
+		buf,
 		clientCacheHit,
 		http);
 	}
@@ -2109,6 +2116,7 @@
 	    http->log_type = LOG_TCP_MISS;
 	    clientProcessMiss(http);
 	}
+	memFree(buf, MEM_CLIENT_SOCK_BUF);
     } else if (r->flags.ims) {
 	/*
 	 * Handle If-Modified-Since requests from the client
@@ -2116,6 +2124,7 @@
 	if (mem->reply->sline.status != HTTP_OK) {
 	    debug(33, 4) ("clientCacheHit: Reply code %d != 200\n",
 		mem->reply->sline.status);
+	    memFree(buf, MEM_CLIENT_SOCK_BUF);
 	    http->log_type = LOG_TCP_MISS;
 	    clientProcessMiss(http);
 	} else if (modifiedSince(e, http->request)) {
@@ -2124,6 +2133,7 @@
 	} else {
 	    MemBuf mb = httpPacked304Reply(e->mem_obj->reply);
 	    http->log_type = LOG_TCP_IMS_HIT;
+	    memFree(buf, MEM_CLIENT_SOCK_BUF);
 	    storeUnregister(e, http);
 	    storeUnlockObject(e);
 	    e = clientCreateStoreEntry(http, http->request->method, null_request_flags);
@@ -2392,7 +2402,7 @@
     MemBuf mb;
     ssize_t check_size = 0;
     debug(33, 5) ("clientSendMoreData: %s, %d bytes\n", http->uri, (int) size);
-    assert(size <= SM_PAGE_SIZE); /* We work in SM_PAGE_SIZE chunks now */
+    assert(size <= CLIENT_SOCK_SZ);
     assert(http->request != NULL);
     dlinkDelete(&http->active, &ClientActiveRequests);
     dlinkAdd(http, &http->active, &ClientActiveRequests);
@@ -2401,18 +2411,22 @@
     if (conn->chr != http) {
 	/* there is another object in progress, defer this one */
 	debug(33, 1) ("clientSendMoreData: Deferring %s\n", storeUrl(entry));
+	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	return;
     } else if (entry && EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
 	/* call clientWriteComplete so the client socket gets closed */
 	clientWriteComplete(fd, NULL, 0, COMM_OK, http);
+	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	return;
     } else if (size < 0) {
 	/* call clientWriteComplete so the client socket gets closed */
 	clientWriteComplete(fd, NULL, 0, COMM_OK, http);
+	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	return;
     } else if (size == 0) {
 	/* call clientWriteComplete so the client socket gets closed */
 	clientWriteComplete(fd, NULL, 0, COMM_OK, http);
+	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	return;
     }
     if (http->out.offset == 0) {
@@ -2442,14 +2456,13 @@
 	    http->range_iter.prefix_size = rep->hdr_sz;
 	    debug(33, 3) ("clientSendMoreData: Appending %d bytes after %d bytes of headers\n",
 		body_size, rep->hdr_sz);
-	} else if (size < SM_PAGE_SIZE && entry->store_status == STORE_PENDING) {
+	} else if (size < CLIENT_SOCK_SZ && entry->store_status == STORE_PENDING) {
 	    /* wait for more to arrive */
-            /* XXX With no copy :) */
 	    storeClientCopy(entry,
 		http->out.offset + size,
 		http->out.offset,
-		0,
-		NULL,
+		CLIENT_SOCK_SZ,
+		buf,
 		clientSendMoreData,
 		http);
 	    return;
@@ -2523,6 +2536,8 @@
 	assert(check_size == size);
     /* write */
     comm_write_mbuf(fd, mb, clientWriteComplete, http);
+    /* if we don't do it, who will? */
+    memFree(buf, MEM_CLIENT_SOCK_BUF);
 }
 
 static void
@@ -2560,8 +2575,8 @@
 	    storeClientCopy(entry,
 		http->out.offset,
 		http->out.offset,
-		0,
-		NULL,
+		CLIENT_SOCK_SZ,
+		memAllocate(MEM_CLIENT_SOCK_BUF),
 		clientSendMoreData,
 		http);
 	}
@@ -2651,8 +2666,8 @@
 	storeClientCopy(entry,
 	    http->out.offset,
 	    http->out.offset,
-	    0,
-	    NULL,
+	    CLIENT_SOCK_SZ,
+	    memAllocate(MEM_CLIENT_SOCK_BUF),
 	    clientSendMoreData,
 	    http);
     }
@@ -2813,8 +2828,8 @@
 	storeClientCopy(http->entry,
 	    http->out.offset,
 	    http->out.offset,
-	    0,
-	    NULL,
+	    CLIENT_SOCK_SZ,
+	    memAllocate(MEM_CLIENT_SOCK_BUF),
 	    clientCacheHit,
 	    http);
     } else {
Index: squid/src/comm_select.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm_select.c,v
retrieving revision 1.1.1.3.10.2.2.1
retrieving revision 1.1.1.3.10.2.2.2
diff -u -r1.1.1.3.10.2.2.1 -r1.1.1.3.10.2.2.2
--- squid/src/comm_select.c	22 Apr 2000 20:02:55 -0000	1.1.1.3.10.2.2.1
+++ squid/src/comm_select.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.2.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: comm_select.c,v 1.1.1.3.10.2.2.1 2000/04/22 20:02:55 hno Exp $
+ * $Id: comm_select.c,v 1.1.1.3.10.2.2.2 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 5     Socket Functions
  *
@@ -658,8 +658,6 @@
 #if !ALARM_UPDATES_TIME
 	getCurrentTime();
 #endif
-	/* Handle any fs callbacks that need doing */
-	storeDirCallback();
 #if DELAY_POOLS
 	FD_ZERO(&slowfds);
 #endif
Index: squid/src/dns_internal.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/dns_internal.c,v
retrieving revision 1.1.1.1.10.4
retrieving revision 1.1.1.1.10.4.2.1
diff -u -r1.1.1.1.10.4 -r1.1.1.1.10.4.2.1
--- squid/src/dns_internal.c	20 Apr 2000 23:20:47 -0000	1.1.1.1.10.4
+++ squid/src/dns_internal.c	2 May 2000 22:50:29 -0000	1.1.1.1.10.4.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: dns_internal.c,v 1.1.1.1.10.4 2000/04/20 23:20:47 hno Exp $
+ * $Id: dns_internal.c,v 1.1.1.1.10.4.2.1 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 78    DNS lookups; interacts with lib/rfc1035.c
  * AUTHOR: Duane Wessels
@@ -146,7 +146,7 @@
 	    t = strtok(NULL, w_space);
 	    if (t == NULL)
 		continue;;
-	    debug(78, 1) ("idnsParseResolvConf: nameserver %s\n", t);
+	    debug(78, 1) ("Adding nameserver %s from %s\n", t, _PATH_RESOLV_CONF);
 	    idnsAddNameserver(t);
 	}
     }
Index: squid/src/enums.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/enums.h,v
retrieving revision 1.1.1.3.10.5
retrieving revision 1.1.1.3.10.5.2.1
diff -u -r1.1.1.3.10.5 -r1.1.1.3.10.5.2.1
--- squid/src/enums.h	22 Apr 2000 09:18:51 -0000	1.1.1.3.10.5
+++ squid/src/enums.h	2 May 2000 22:50:29 -0000	1.1.1.3.10.5.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: enums.h,v 1.1.1.3.10.5 2000/04/22 09:18:51 hno Exp $
+ * $Id: enums.h,v 1.1.1.3.10.5.2.1 2000/05/02 22:50:29 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -515,6 +515,7 @@
 #endif
     MEM_CLIENTHTTPREQUEST,
     MEM_CLIENT_INFO,
+    MEM_CLIENT_SOCK_BUF,
     MEM_CLOSE_HANDLER,
     MEM_COMMWRITESTATEDATA,
     MEM_CONNSTATEDATA,
Index: squid/src/filemap.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/filemap.c,v
retrieving revision 1.1.1.2.6.1
retrieving revision 1.1.1.2.6.1.2.1
diff -u -r1.1.1.2.6.1 -r1.1.1.2.6.1.2.1
--- squid/src/filemap.c	20 Apr 2000 18:14:22 -0000	1.1.1.2.6.1
+++ squid/src/filemap.c	2 May 2000 22:50:29 -0000	1.1.1.2.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: filemap.c,v 1.1.1.2.6.1 2000/04/20 18:14:22 hno Exp $
+ * $Id: filemap.c,v 1.1.1.2.6.1.2.1 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 8     Swap File Bitmap
  * AUTHOR: Harvest Derived
@@ -133,7 +133,7 @@
     for (bit = 0; bit < BITS_IN_A_LONG; bit++) {
 	suggestion = ((unsigned long) word << LONG_BIT_SHIFT) | bit;
 	if (!file_map_bit_test(fm, suggestion)) {
-	    return file_map_bit_set(fm, suggestion);
+	    return suggestion;
 	}
     }
     debug(8, 3) ("growing from file_map_allocate\n");
Index: squid/src/forward.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/forward.c,v
retrieving revision 1.1.1.3.10.3
retrieving revision 1.1.1.3.10.3.2.1
diff -u -r1.1.1.3.10.3 -r1.1.1.3.10.3.2.1
--- squid/src/forward.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.10.3
+++ squid/src/forward.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.3.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: forward.c,v 1.1.1.3.10.3 2000/04/20 18:14:22 hno Exp $
+ * $Id: forward.c,v 1.1.1.3.10.3.2.1 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 17    Request Forwarding
  * AUTHOR: Duane Wessels
@@ -195,8 +195,10 @@
 	debug(17, 3) ("fwdConnectDone: FD %d: '%s'\n", server_fd, storeUrl(fwdState->entry));
 	if (fs->peer)
 	    hierarchyNote(&fwdState->request->hier, fs->code, fs->peer->host);
-	else
+	else if (Config.onoff.log_ip_on_direct)
 	    hierarchyNote(&fwdState->request->hier, fs->code, fd_table[server_fd].ipaddr);
+	else
+	    hierarchyNote(&fwdState->request->hier, fs->code, request->host);
 	fd_note(server_fd, storeUrl(fwdState->entry));
 	fd_table[server_fd].uses++;
 	if (fs->peer)
Index: squid/src/mem.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/mem.c,v
retrieving revision 1.1.1.3.10.3
retrieving revision 1.1.1.3.10.3.2.1
diff -u -r1.1.1.3.10.3 -r1.1.1.3.10.3.2.1
--- squid/src/mem.c	20 Apr 2000 18:14:22 -0000	1.1.1.3.10.3
+++ squid/src/mem.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.3.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: mem.c,v 1.1.1.3.10.3 2000/04/20 18:14:22 hno Exp $
+ * $Id: mem.c,v 1.1.1.3.10.3.2.1 2000/05/02 22:50:29 hno Exp $
  *
  * DEBUG: section 13    High Level Memory Pool Management
  * AUTHOR: Harvest Derived
@@ -189,6 +189,7 @@
     memDataInit(MEM_2K_BUF, "2K Buffer", 2048, 10);
     memDataInit(MEM_4K_BUF, "4K Buffer", 4096, 10);
     memDataInit(MEM_8K_BUF, "8K Buffer", 8192, 10);
+    memDataInit(MEM_CLIENT_SOCK_BUF, "Client Socket Buffer", CLIENT_SOCK_SZ, 0);
     memDataInit(MEM_ACCESSLOGENTRY, "AccessLogEntry",
 	sizeof(AccessLogEntry), 10);
     memDataInit(MEM_ACL, "acl", sizeof(acl), 0);
